#!/usr/bin/perl

use strict;
use warnings;
use Lib_Raid_Rpc;

use Data::Dumper;

use JSON::PP;
use XML::Hash::LX;

our %config;

do '../../web-lib.pl';
do '../../ui-lib.pl';
&init_config();

my $raidinfo = Lib_Raid_Rpc::get_all_info();

# print "Content-type: text/plain\n\n";
# print Dumper $raidinfo;
# exit;

my $data;

if ($config{apiformat} == 0 ) {
    $data = encode_json($raidinfo);
    print "Content-type: application/json\n\n";
} else {
    $data = hash2xml($raidinfo, utf8 => 1, root => 'raid', indent => 2);
    #cleanup slashes /
    #$data =~ s#(/dev(/\w+)+)#"$1"#g ;        
    $data =~ s#<(/dev(/\w+)+)>#<drive name="$1">#g ;        
    $data =~ s#</(/dev(/\w+)+)>#</drive>#g ;        
    print "Content-type: application/xml\n\n";
}
print $data;
