#!/usr/bin/perl -w
#
###########################################################################
#
# html.pm
# V 0.1.0 du 11/12/2004
#
###########################################################################
# 
#    Copyright (c) Intellique 2004
#    All rights reserved.
#
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

use strict;
require Exporter;

our @ISA=qw(Exporter);
our @EXPORT=qw(print_debut print_fin);

############################################################################
#			Fonctions exportes
############################################################################

sub print_debut {
	my $title		= shift;
	my $hostname	= shift;

print <<EOF;
<html>
<head>
	<title>$title -- $hostname --</title>
	<link rel="STYLESHEET" type="text/css" href="css/classic.css">
</head>


<body dir="ltr"><center><h1>$title : $hostname</h1></center>

<table align="center" width="100%"><tbody><tr><td valign="top" width="50%">
EOF
}

	
sub print_fin {
print <<EOF;
</td></tr></tbody></table>

</body>
</html>
EOF
}

sub print_box_debut {
	my $title = shift;

print <<EOF;
   <table width="100%"><tbody><tr><td>
    <table class="box"><tbody><tr class="boxheader"><td class="boxheader">$title</td></tr>
     <tr class="boxbody"><td>
     <table align="center" border="0" width="90%"><tbody>
EOF
}

sub print_box_fin {
	print "      </tbody></table>";
	print "     </td></tr>";
	print "    </tbody></table>";
	print "   </td></tr>";
	print "  </tbody></table>";
}

sub print_ligne_simple {
	my $title = shift;
	my $texte = shift;
	
	print "<tr><td valign=\"top\"><font size=\"-1\">$title</font></td><td><font size=\"-1\">$texte</font></td></tr>";
}

sub print_ligne_reseau {
	my @param = @_;

print <<EOF;
	<tr>
	<td align="left" valign="top"><font size="-1">$param[0]</font></td>
	<td align="right" valign="top"><font size="-1">$param[1]</font></td>
	<td align="right" valign="top"><font size="-1">$param[2]</font></td>
	<td align="right" valign="top"><font size="-1">$param[3]/$param[4]</font></td>
	</tr>
EOF
}

sub print_ligne_memoire {
	my @param = @_;
	
print <<EOF;
	<tr>
	<td align="left" valign="top"><font size="-1">$param[0]</font></td>
	<td align="left" valign="top"><font size="-1">$param[1]</font></td>
	<td align="right" valign="top"><font size="-1">$param[2]</font></td>
	<td align="right" valign="top"><font size="-1">$param[3]</font></td>
	<td align="right" valign="top"><font size="-1">$param[4]</font></td>
	</tr>
EOF
}

sub print_ligne_filesystem {
	my @param = @_;
	
print <<EOF;
	<tr>
	<td align="left" valign="top"><font size="-1">$param[0]</font></td>
	<td align="left" valign="top"><font size="-1">$param[1]</font></td>
	<td align="left" valign="top"><font size="-1">$param[2]</font></td>
	<td align="left" valign="top"><font size="-1">$param[3]</font></td>
	<td align="right" valign="top"><font size="-1">$param[4]</font></td>
	<td align="right" valign="top"><font size="-1">$param[5]</font></td>
	<td align="right" valign="top"><font size="-1">$param[6]</font></td>
	</tr>
EOF
}

sub print_ligne_filesystem_totaux {
	my @param = @_;
	
print <<EOF;
	<tr>
	<td colspan="3" align="right" valign="top"><font size="-1"><i>Totaux :&nbsp;&nbsp;</i></font></td>
	<td align="left" valign="top"><font size="-1">$param[0]</font></td>
	<td align="right" valign="top"><font size="-1">$param[1]</font></td>
	<td align="right" valign="top"><font size="-1">$param[2]</font></td>
	<td align="right" valign="top"><font size="-1">$param[3]</font></td>
	</tr>
EOF
}

sub print_ligne_controleur {
	my @param = @_;
	
print <<EOF;
	<tr>
	<td align="left" valign="top" width="230"><font size="-1">$param[0]</font></td>
	<td align="left" valign="top"><font size="-1">$param[1]</font></td>
	<td align="left" valign="top"><font size="-1">$param[2]</font></td>
	<td align="left" valign="top"><font size="-1">$param[3]</font></td>
	<td align="left" valign="top"><font size="-1">$param[4]</font></td>
	<td align="right" valign="top"><font size="-1">$param[5]</font></td>
	</tr>
EOF
}

sub print_ligne_controleur_red {
	my @param = @_;
	
print <<EOF;
	<tr class="red">
	<td align="left" valign="top"><font size="-1">$param[0]</font></td>
	<td align="left" valign="top"><font size="-1" class="red">$param[1]</font></td>
	<td align="left" valign="top"><font size="-1" class="red">$param[2]</font></td>
	<td align="left" valign="top"><font size="-1" class="red">$param[3]</font></td>
	<td align="left" valign="top"><font size="-1" class="red">$param[4]</font></td>
	<td align="right" valign="top"><font size="-1" class="red">$param[5]</font></td>
	</tr>
EOF
}

sub print_ligne_error {
	my $param = shift;

print <<EOF;
	<tr>
	<td align="center" valign="top"><font size="-1"><b>$param</b></font></td>
	</tr>
EOF

}

##########################################
#   fin
##########################################

1;
