#!/usr/bin/perl -w
######### PROJECT NAME : ##########
## 
## save_bond.cgi 
## 
###################################

use Data::Dumper;

do '../web-lib.pl';
require '../ui-lib.pl';
require './bonding-lib.pl';

&init_config();
&ReadParse();


#Annulation
retour_index() if ( exists $in{'cancel'} );


#Nouveau bonding
if ( exists $in{'save_new'} ) {
    my @list;
    foreach my $k ( keys %in ) {
        push @list, $in{ $k } if ( $k =~ m/^eth/ );
    }

    print_error( &create_bond(  $in{'bond'}, $in{'mode'}    ) );
    print_error( &add_if(       $in{'bond'}, @list          ) );
    print_error( &bond_state(   $in{'bond'}, $in{'status'}  ) );

    retour_index();
}
#Modifcation bonding
elsif ( exists $in{'save'} ) {
    my %hash = status();
    my $bond = $hash{ $in{ 'bond' } };

    if ( $hash{ $in{ 'bond' } }{ 'Status' } ne $in{ 'status' } ) {
        print_error( &bond_state(   $in{'bond'}, $in{'status'}  ) );
    }

    if ( $hash{ $in{ 'bond' } }{ 'Mode' } ne $in{ 'mode' } ) {
        print_error( &set_mode(   $in{'bond'}, $in{'mode'}  ) );
    }

    my %hash_iface_old = map { $_ => "" } @{ $hash{ $in{ 'bond' } }{ 'Slaves' } };
    my @list_new;
    foreach my $k ( keys %in ) {
        next unless ( $k =~ m/^eth/ );

        if ( exists $hash_iface_old{ $in{ $k } } ) {
            delete $hash_iface_old{ $in{ $k } };
        }
        else {
            print_error( &add_if( $in{'bond'}, $in{ $k } ) );
        }
    }

    foreach my $k ( keys %hash_iface_old ) {
        print_error( &del_if( $in{'bond'}, $k ) );
    }

    retour_index();
}
#Suppresion bonding
elsif ( exists $in{'delete'} ) {
    print_error( &delete_bond( $in{'bond'} ) );
    retour_index();
}
else {
    &ui_print_header(undef, $text{'index_title'}, undef, undef, 0, 1, 0, undef, undef, undef, undef);

	print "<pre>";
	print Dumper \%in;
	print "</pre>";

    &footer(undef, $text{'index'});
}



sub print_error {
    my ($err, $mess) = @_;
    return unless ( $err );

    &ui_print_header(undef, $text{'index_title'}, undef, undef, 0, 1, 0, undef, undef, undef, undef);
    print "Error : ". $mess ."<br><br>";
    &footer(undef, $text{'index'});
    exit 1;
}

sub retour_index {
    &redirect("");
    exit 0;
}
