#!/usr/bin/perl -w 
## ######### PROJECT NAME : ##########
##
## ajax.pm for ajax.pm in /mnt/42/cedric/site/lib
##
## ######### PROJECT DESCRIPTION : ###
##
## Package Ajax Intellique
##
## ###################################
##
## Made by husianycia cedric
## Login   <root@intellique.com>
##
## Started on  Mon Nov 21 12:28:00 2005 husianycia cedric
## Last update Mon Apr 23 18:23:49 2007 husianycia cedric
##
## ###################################
##

###
### Le probleme est que les partitions vide collent pas
### Il faut sauter les doublons :)
##
## ###################################
## Declaration du package

package paging;

##
## ###################################
## Declaration des libs

use strict;
use CGI qw(:standard);

use Lib_Disk;

##
## ###################################
## Declaration de variables

my $cgi;
my $html_path  = "./html/";
my $delimiteur = "VAR_";

# Taille mini d'une partition en octets
my $taille_mini = 18000000;
my $ecart_max   = 5;

##
## ###################################
## Methode de creation de l'html

sub gen_html {
    my $lang = shift;
    $cgi = new CGI;
    print $cgi->header;

    my $html = _load( $html_path . "head.html" );

    my %best;
    %best = %{$lang};

    $best{tab} = create_message( \%best );

    $html .= _parse( $delimiteur, _load( $html_path . "index.html" ), %best );

    $html .= _load( $html_path . "feet.html" );

    return $html;
}

##
## ###################################
## Fait un sort numerique

sub numeric {
    if    ( $a < $b )  { -1; }
    elsif ( $a == $b ) { 0; }
    else               { +1; }
}

##
## ###################################
## Fait un sort numerique de nom de partition

sub numerically {
    my $A = $a;
    my $B = $b;
    $A =~ s/[a-zA-Z\/\s\\-]*(\d+)$/$1/;
    $B =~ s/[a-zA-Z\/\s\\-]*(\d+)$/$1/;
    if    ( $A < $B )  { -1; }
    elsif ( $A == $B ) { 0; }
    else               { +1; }
}

##
## ###################################
## sqrt, fait un sqrt sur l'int

sub fct_sqrt {
    my $value = shift;
    return 0 if ( $value < 0 );
    return sqrt($value);
}

##
## ###################################
## Supprime une value d'un tableau

sub delete_value {
    my $value  = shift;
    my @OldTab = @_;
    my @NewTab;

    foreach (@OldTab) {
        push @NewTab, $_ unless ( $_ == $value );
    }

    return @NewTab;
}

##
## ###################################
## Passage en octects et jolitude de la chose

sub arrange {
    my $start = shift;

    $start = $start * 100 / 1024 / 1024 / 1024;
    if ( $start >= 100 ) {
        $start = int($start);
        $start =~ s/(\d*)(\d{2})$/$1,$2/;
    } elsif ( $start >= 10 ) {
        $start = int($start);
        $start =~ s/(\d{2})$/0,$1/;
    } elsif ( $start >= 1 ) {
        $start = int($start);
        $start =~ s/(\d*)/0,0$1/;
    } else {
        $start = "0,00";
    }
    return $start;
}

##
## ###################################
## Creation de la page web

sub create_message {

    # hash de langue
    my $hashref = shift;
    my %best    = %{$hashref};

    # hash de info-disk
    my $disk_ref = Lib_Disk::get_disk_info();
    my %disk     = %{$disk_ref};

    # Autres variables
    my $ret   = "";
    my $parit = "callbackpair";

    # On parcourt les devices
    foreach my $dev ( sort keys(%disk) ) {

        #		# On initialise notre compteur a 1
        #	$. = 1;

        # Taille de la device
        my $size_go = $disk{$dev}{size};

        # On sauvegarde cette taille
        my $size_save = $size_go;

        # On passe en Go cette size et on la fait joulie
        $size_go = $size_go / 1024 / 1024 / 1024;
        $size_go =~ s/^([0-9]*)\.([0-9]{2}).*/$1,$2/;

        # $tmp contient l'html
        my $tmp = "";

        # Si on a une taille de device
        if ($size_go) {
            $ret .=
                '<tr class="part"><td><b>' 
              . $dev
              . '</b></td><td>&nbsp;</td><td>&nbsp;</td><td>'
              . $size_go
              . ' Go</td></tr>';
        }    # Sinon ...
        else {
            $ret .=
                '<tr class="part"><td><b>' 
              . $dev
              . '</b></td><td>&nbsp;</td><td>&nbsp;</td><td></td></tr>';
        }

####################################
### Calcul pour les partitions vides
####################################

        # Tableau contenant la fin des partition
        # cad le debut de l'espace vide
        my @end_reste = '0';

        # Tableau contenant le debut des partition
        # cad la fin de l'espace vide
        my @start_reste;

        # On parcours la liste des partitions
        if ( ref $disk{$dev}{partition} eq 'HASH' ) {
            foreach my $partition ( keys( %{ $disk{$dev}{partition} } ) ) {

                # Si la partition debute apres la taille mini
                if ( $disk{$dev}{partition}{$partition}{start} > $taille_mini )
                {

                    # On place dans notre tableau le debut
                    # Ce sera donc la fin de l'espace vide
                    # ..ou le debut d'une nouvelle
                    push( @start_reste,
                        $disk{$dev}{partition}{$partition}{start} );

                } else {
                    push( @start_reste, '0' );
                }

                # On remplis end-reste avec la fin des partitions
                # ...ce sera donc un debut de vide ou debut de
                # nouvelle
                push( @end_reste, $disk{$dev}{partition}{$partition}{end} );

            }
        }

        # On met dans start_reste la taille de la device
        # ... au cas ou :D
        push( @start_reste, $disk{$dev}{size} );

        # On parcours les tableaux pour recuperer les partitions proches
        foreach my $end_tmp ( sort numeric @end_reste ) {
            foreach my $start_tmp (@start_reste) {
                if ( $ecart_max > ( $end_tmp - $start_tmp )
                    and ( $end_tmp - $start_tmp ) > -$ecart_max )
                {

                    # On supprime sa valeur dans nos tableau
                    @start_reste = delete_value( $start_tmp, @start_reste );
                    @end_reste   = delete_value( $end_tmp,   @end_reste );
                }
            }
        }

        # Nb d'espaces vides
        my $vide = 1;

        foreach my $ender ( sort numeric @end_reste ) {
            my $flag_sorti = 0;
            foreach my $starter ( sort numeric @start_reste ) {

                if ( $flag_sorti == 1 ) {
                    next;
                }

                # On remplis notre hash avec espace vide
                if ( ref $disk{$dev}{partition} eq 'HASH' ) {
                    if ( $starter > $ender ) {
                        $disk{$dev}{partition}{ "EV" . $vide }{"start"} =
                          $ender;
                        $disk{$dev}{partition}{ "EV" . $vide }{"end"} =
                          $starter;
                        $disk{$dev}{partition}{ "EV" . $vide }{"size"} =
                          $starter - $ender;
                        $disk{$dev}{partition}{ "EV" . $vide }{"VIDE"} = 1;
                        $disk{$dev}{partition}{ "EV" . $vide }{"filesystem"} =
                          "";

                        @start_reste = delete_value( $starter, @start_reste );
                        @end_reste   = delete_value( $ender,   @end_reste );
                        $flag_sorti  = 1;
                    }
                }
            }
            $vide++;
        }

########################################
### Fin calcul pour les partitions vides
########################################

        # sqrt total de la device
        my $s_total = 0;

        # l'espace vide
        my $s_reste = 0;

        # On parcours la liste des partitions
        if ( ref $disk{$dev}{partition} eq 'HASH' ) {
            foreach my $partition ( keys( %{ $disk{$dev}{partition} } ) ) {

                # On ajoute le sqrt de la taille de chaque partition
                $s_total +=
                  fct_sqrt( $disk{$dev}{partition}{$partition}{size} );

                # On ajoute la taille de chaque partition
                # afin de calculer le reste
                $s_reste += $disk{$dev}{partition}{$partition}{size};
            }
        }

        # Le reste = taille device - taille des partitions
        $s_reste = $size_save - $s_reste;

        my $s_position = 0;

        my %hash;

        # Cette hash va contenir une cl en plus
        # afin de pouvoir sorter numeric
        if ( ref $disk{$dev}{partition} eq 'HASH' ) {
            foreach
              my $paart ( sort numerically keys( %{ $disk{$dev}{partition} } ) )
            {

                $hash{ $disk{$dev}{partition}{$paart}{start} }{$paart} =
                  \%{ $disk{$dev}{partition}{$paart} };

            }
        }

        # On peut donc maintenant faire notre sort
        # comme ca on a les part dans l'ordre
        foreach my $start_value ( sort numeric keys(%hash) ) {
            $parit = " callbackimpair " if ( $. % 2 );
            $parit = " callbackpair " unless ( $. % 2 );

            my ($partition) = keys( %{ $hash{$start_value} } );

            my $end   = $disk{$dev}{partition}{$partition}{end};
            my $start = $disk{$dev}{partition}{$partition}{start};
            my $size  = $disk{$dev}{partition}{$partition}{size};

            my $start_save = $start;
            my $end_save   = $end;
            my $size2_save = $size;

            $start = arrange($start);
            $end   = arrange($end);
            $size  = arrange($size);

            # On check l'espace utilis
            my $arf = $partition;
            $arf =~ s/(\/dev\/[a-z]*\d).*/$1/;
            my $space_used = qx#df | grep $arf#;
            my $total_used = 0;

            if ($space_used) {
                $space_used =~ /^[\/a-z0-9]*\s*(\d*)\s*(\d*).*/;
                $space_used = int($2);
                $total_used = int($1);
            }

            my $part_tmp = $partition;

            # Si la partition est un espace vide...
            if ( $partition =~ /^EV\d*/i ) {
                $part_tmp = $best{'libre'};
                next
                  if ( $disk{$dev}{partition}{$partition}{start} >
                    ( $size_save - $taille_mini ) );
                next
                  if (
                    $disk{$dev}{partition}{$partition}{size} < $taille_mini );
            }

            # Utilisation de la swap...
            my @swap;
            if ( $disk{$dev}{partition}{$partition}{filesystem} =~ /swap/i ) {
                @swap = qx#/bin/cat /proc/meminfo | grep " ^ Swap [TF] "#;
                $swap[0] =~ s/[a-z:\s]*(\d*)[\skb]*/$1/i;
                $swap[1] =~ s/[a-z:\s]*(\d*)[\skb]*/$1/i;
                $swap[1] = $swap[0] - $swap[1];
            }

            # On remplis l'html
            $tmp = '<tr class="' . $parit . '
"><td>REMPLIRGRAPH</td><td>'
              . $part_tmp
              . '</td><td>'
              . $disk{$dev}{partition}{$partition}{filesystem}
              . '</td><td>'
              . $size
              . ' Go</td></tr>';

            $.++;

            # Creation du tableau complet...

            my $end_cpt = 549;

            my $rendu = "";

            my $s_size_save  = fct_sqrt($size2_save);
            my $s_start_save = $s_position;
            my $s_end_save =
              $s_position + $s_size_save * ( $end_cpt + 1 ) / $s_total;

            my $end_used = 0;
            if ($total_used) {
                $end_used = $space_used * ( $end_cpt + 1 ) / $total_used;
                $end_used = $s_position + $s_size_save * $end_used / $s_total;
            }

            my $swap_used = 0;
            if ( $swap[0] ) {
                $swap_used = $swap[1] * ( $end_cpt + 1 ) / $swap[0];
                $swap_used = $s_position + $s_size_save * $swap_used / $s_total;
            }

            $s_position = $s_end_save;

            unless ($space_used) { $end_used = 0 }

            foreach my $count ( 1 ... $end_cpt ) {
                my $color = "empty.jpg ";
                if ( $count >= $s_start_save ) {
                    $color = "using.jpg ";
                    if ( $disk{$dev}{partition}{$partition}{VIDE} ) {
                        $color = "vert.jpg ";
                    }
                    if ( $count < $end_used || $count < $swap_used ) {
                        $color = "rouge.jpg ";
                    }

                }
                if ( $count > $s_end_save ) {
                    $color = "empty.jpg ";
                }

                $rendu .= '<IMG height="25" src="./images/' . $color . '">';
            }

            $tmp =~ s/REMPLIRGRAPH/$rendu/;

            $ret .= $tmp;
        }
    }

    # Creation de la legende...

    my @color_list = ( "using.jpg", "rouge.jpg", "vert.jpg" );

    $ret .= qq(</td></tr></table><br> <table align="left"> <tr> <td> &nbsp;
                          </td> <td> $best{legende} </td></tr>);

    foreach my $list ( 0 ... 2 ) {
        $ret .= "<tr><td>";
        foreach ( 1 ... 25 ) {
            $ret .=
              '<IMG height=" 25 " src="./images/' . $color_list[$list] . '">';
        }
        if ( $list == 0 ) {
            $ret .= " </td><td>" . $best{'position'} . "</td></tr>";
        }

        if ( $list == 1 ) {
            $ret .= " </td><td>" . $best{'occup'} . "</td></tr>";
        }

        if ( $list == 2 ) {
            $ret .= " </td><td>" . $best{'nopart'} . "</td></tr>";
        }
    }

    return $ret;

}

##
## ###################################
## Methode de chargement html

sub _load {
    my $path = shift;

    my $ret;
    if ( -f $path ) {
        open( FILE, $path ) or die(" $! ");

        foreach (<FILE>) {
            next if ( $_ =~ /^\#/ );
            $ret .= $_;
        }

        close(FILE);
    }
    return $ret;
}

sub _parse {

    # recoit un delimiteur une variable et une hash
    # Modifie la variable et la renvoie

    my ( $delim, $var, %replace ) = @_;

    # On verifie les parametres recus
    return -1 if ( !$delim );
    return -1 if ( !$var );
    return -1 if ( !%replace );

    foreach my $key ( keys(%replace) ) {

        my $init = $delim . $key;
        $var =~ s/$init/$replace{$key}/g;

    }

    $var =~ s/($delim([a-z0-9]*))/&nbsp/g;

    return $var;
}

##
## ###################################
## fin

1;

