#!/usr/bin/perl
# index_top.cgi
# Display the top frame using the Intellique icons and style

require './web-lib.pl';
&init_config();
$hostname = &get_system_hostname();
$ver = &get_webmin_version();
if ($gconfig{'real_os_type'}) {
	$ostr = "$gconfig{'real_os_type'} $gconfig{'real_os_version'}";
	}
else {
	$ostr = "$gconfig{'os_type'} $gconfig{'os_version'}";
	}

# Build a list of all modules
&read_acl(\%acl);
opendir(DIR, ".");
$user = $base_remote_user;
$risk = $gconfig{'risk_'.$user};
foreach $d (readdir(DIR)) {
	local %minfo;
	if ($d !~ /^config-/ && (%minfo = &get_module_info($d))) {
		if (!&check_os_support(\%minfo)) {
			# This OS is not supported!
			next;
			}
		if ($risk) {
			# Check module risk level
			next if ($risk ne 'high' && $minfo{'risk'} &&
				 $minfo{'risk'} !~ /$risk/);
			}
		else {
			# Check specific ACL
			next if (!$acl{$user,$d} && !$acl{$user,"*"});
			}
		push(@modules, \%minfo);
		}
	}
closedir(DIR);
@modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;

# Work out what categories exist, and which is current
&ReadParse();
&read_file("$config_directory/webmin.catnames", \%catnames);
foreach $m (@modules) {
	$c = $m->{'category'};
	next if ($cats{$c});
	if ($catnames{$c}) {
		$cats{$c} = $catnames{$c};
		}
	elsif ($text{"category_$c"}) {
		$cats{$c} = $text{"category_$c"};
		}
	else {
		# try to get category name from module ..
		local %mtext = &load_language($m->{'dir'});
		if ($mtext{"category_$c"}) {
			$cats{$c} = $mtext{"category_$c"};
			}
		else {
			$c = $m->{'category'} = "";
			$cats{$c} = $text{"category_$c"};
			}
		}
	}
@cats = sort { $b cmp $a } keys %cats;
$cats = @cats;
$per = $cats ? 100.0 / $cats : 100;
if (!defined($in{'cat'})) {
	# Use default category
	if (defined($gconfig{'deftab'})) {
		$in{'cat'} = $gconfig{'deftab'};
		}
	else {
		$in{'cat'} = $cats[0];
		}
	}
elsif (!$cats{$in{'cat'}}) {
	$in{'cat'} = "";
	}

# Display title and categories
&PrintHeader();
print <<EOF;
<!doctype html public \"-//W3C//DTD HTML 3.2 Final//EN\">
<HTML>

<HEAD>
<LINK REL="stylesheet" TYPE="text/css" HREF="style.css">
</HEAD>

<BODY LINK="#FFFFFF" VLINK="#FFFFFF" MARGINWIDTH="0" MARGINHEIGHT="0" LEFTMARGIN="0" TOPMARGIN="0" BACKGROUND="images/navbg.gif">

  <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%" HEIGHT="1" BGCOLOR="#FFFFFF">
    <TR>
      <TD HEIGHT="100"  VALIGN="top" ALIGN="left" WIDTH=100% background="images/Storiq.png" BGCOLOR="#000" STYLE="background-repeat: no-repeat;"><br></TD>
      <TD WIDTH="100%" HEIGHT="1" ALIGN="LEFT" VALIGN="BOTTOM" BGCOLOR="#000">
        <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" BGCOLOR="#000" WIDTH="100%">
          <TR>
EOF
foreach $c (@cats) {
	if ($in{'cat'} eq $c) {
		print "<TD width=\"1%\" HEIGHT=\"24\" BACKGROUND=\"images/folder-on.gif\" VALIGN=\"TOP\" ALIGN=\"LEFT\"><IMG SRC=\"images/spacer.gif\" HEIGHT=\"6\" WIDTH=\"72\"><BR><NOBR><IMG SRC=\"images/spacer.gif\" WIDTH=\"6\" HEIGHT=\"1\"><TABLE WIDTH=\"72\" CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"0\" BACKGROUND=\"\"><TR><TD><CENTER><SPAN CLASS=\"navActive2\">$cats{$c}</SPAN></CENTER></TD></TR></TABLE></NOBR></TD>\n";
		}
	else {
		print "<TD width=\"1%\" HEIGHT=\"24\" BACKGROUND=\"images/folder-off.gif\" VALIGN=\"TOP\" ALIGN=\"LEFT\"><IMG SRC=\"images/spacer.gif\" HEIGHT=\"6\" WIDTH=\"72\"><BR><NOBR><IMG SRC=\"images/spacer.gif\" WIDTH=\"6\" HEIGHT=\"1\"><TABLE WIDTH=\"72\" CELLPADDING=\"0\" CELLSPACING=\"0\" BORDER=\"0\" BACKGROUND=\"\"><TR><TD><CENTER><A TARGET=\"left\" HREF=\"index_left.cgi?cat=$c\" CLASS=\"navInactive\">$cats{$c}</A></CENTER></TD></TR></TABLE></NOBR></TD>\n";
		}
	}
$vtext =&text('main_title', $ver, $hostname, $ostr)
	if (!$gconfig{'nohostname'});
if ($main::session_id) {
	$switch = "<a href=\"session_login.cgi?logout=1\" target=\"_top\" CLASS=\"bodyNav\">".
		  "$text{'main_logout'}</a>";
	}
else {
	$switch = "<a href=\"switch_user.cgi\" target=\"_top\" CLASS=\"bodyNav\">".
	          "$text{'main_switch'}</a>";
	}
print <<EOF;
<TD HEIGHT="24" BACKGROUND="images/folder-off.gif" VALIGN="TOP" ALIGN="RIGHT"><IMG SRC="images/spacer.gif" HEIGHT="6" WIDTH="120"><BR><NOBR><SPAN CLASS="bodyText">&nbsp;&nbsp;</SPAN><A HREF="mailto:support\@intellique.com" CLASS="navInactive2">Support</A><IMG SRC="images/spacer.gif" HEIGHT="1" WIDTH="6"></NOBR></TD></TR></TABLE></TD>
          </TR>
        </TABLE>
      </TD>
    </TR>
    <TR>
      <TD COLSPAN="2" WIDTH="100%" HEIGHT="19">
        <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
          <TR>
            <TD WIDTH="75%" HEIGHT="19"><IMG SRC="images/spacer.gif" WIDTH="95" HEIGHT="1"><SPAN CLASS="EightPoint"><NOBR>$vtext</NOBR></SPAN></TD>
            <TD WIDTH="25%" HEIGHT="19" ALIGN="RIGHT">$switch</TD>
          </TR>
        </TABLE>
      </TD>
    </TR>
</table>
EOF
