#!/usr/bin/perl

# $Id: createlun.cgi 92 2008-07-03 15:48:33Z emmanuel $ 

use strict;
use warnings;

our %text;
our %config;
our %in;

use Data::Dumper;

require './iscsi-lib.pl';
&ReadParse();

&header($text{'createlun_details'}, "", undef, 1, 1, 0, &help_search_link("ietd", "man", "doc"),);

sub createdev {
	# debug
	# print "createdev<pre>" , Dumper \%in , "</pre>";
	
	my %units = ( 'MB' => 1, 'GB' => 1024, 'TB' => 1048576 );
	
	if ( -e $in{lundev} ) {
		print "<h3>$in{lundev} : $text{'error_fileexists'} </h3>";
		return;
	}
	
	my $seek = 0;
	my $lunsize = $in{lunsize} * $units{$in{unit}};

	if ($in{quickinit} eq 'selected') {
		$seek = $lunsize - 1;
		$seek = 0 if $seek < 0;
		$lunsize = 1;
	}
	
	print "Please wait... ";
	_writefile( $in{lundev}, $seek, $lunsize);
	print " ... done.";
	
    print "<br><br><hr>\n<a href=\"edittarget.cgi?action=addlun&target=$in{target}&lundev=$in{lundev}\">$text{auth_index}</a><br><BR>\n";
}

sub resizedev {
	if ( ! -f $in{lundev} ) {
		print "<h3>$text{error_wrongfiletype}</h3>";
   		print "<br><hr>\n<a href=\"javascript:history.back()\">$text{auth_index}</a><br>\n";
		return;
	}
	displaydev();
}

sub doresizedev {
	# debug
	# print "doresizedev ";

	my %units = ( 'MB' => 1, 'GB' => 1024, 'TB' => 1048576 );

	if ( ! -e $in{lundev} ) {
		print "<h3>$in{lundev} : $text{'error_nosuchfile'} </h3>";
		return;
	}

	if ( ! -f $in{lundev} ) {
		print "<h3>$in{lundev} : $text{'error_wrongfiletype'} </h3>";
		return;
	}
	
	my $newsize = $in{lunsize} * $units{$in{unit}};
	my $lunsize = int ((stat($in{lundev}))[7] / 1048576 );
	
	my $seek = $lunsize ;
	$seek = 1 if $seek < 1;
	$newsize -=  $lunsize ;
	
	if ($newsize < 0 ) {
		print "<h3>$text{error_noreduce}</h3>";
		return;
	}

	if ($in{quickinit} eq 'selected') {
		$seek += $newsize - 1 ;
		$newsize = 1;
		}
	
	print "please wait...  ";
	_writefile( $in{lundev}, $seek, $newsize);
	print " ... done.";

    print "<br><br><hr>\n<a href=\"index.cgi\">$text{auth_index}</a><br><BR>\n";

	
}

sub _writefile {
	# debug
	# print "_writefile ";

	my $lundev=shift;
	my $seek=shift;
	my $count=shift;
	
	system($config{ddcommand}, "if=/dev/zero", "of=$lundev", "seek=$seek", "bs=1M", "count=$count") == 0
		or print "<h3>$text{edittarget_failed} '$config{ddcommand} if=/dev/zero of=$lundev seek=$seek bs=1M count=$count'</h3>";
	
}


sub displaydev {
	print &ui_form_start("createlun.cgi", "get");
	my $lunsize = "";

	if ( not $in{action} eq 'resizedev' ) {
		print &ui_table_start($text{'edittarget_createdev'}, undef, 2);
	} else {
		print &ui_table_start($text{'edittarget_resizedev'}, undef, 2);
	}
	
	 
	if ($in{lundev}) {
		$lunsize = int ((stat($in{lundev}))[7] / 1048576 );
	}
	
	if ( not $in{action} eq 'resizedev' ) {
		print &ui_table_row($text{'createlun_lunpath'}, &ui_textbox("lundev", $in{lundev}, 40) . &file_chooser_button("lundev") );
	} else {
		print &ui_hidden("lundev", $in{lundev}) ;
	}
	
	print &ui_table_row($text{'createlun_lunsize'},&ui_textbox("lunsize", $lunsize, 20) .
		&ui_select("unit", "", 
				[ ["MB", $text{'createlun_mb'} ],
				  ["GB", $text{'createlun_gb'} ],
				  ["TB", $text{'createlun_tb'} ] ]) )
		;

	print &ui_table_row($text{'createlun_quickinit'},&ui_checkbox('quickinit', 'selected', '', 'selected') );

	print &ui_table_end();
	print &ui_hidden("target", $in{target}) ;
	print &ui_hidden("lun", $in{lun}) ;
	
	if ( not $in{action} eq 'resizedev' ) {
		print &ui_hidden("action", "createdev") ;
		print &ui_form_end([ [ "docreatedev", $text{'createlun_apply'} ] ]);
	} else {
		print &ui_hidden("action", "doresizedev") ;
		print &ui_form_end([ [ "docreatedev", $text{'createlun_apply'} ] ]);
	}
}

##############################

# actions
my %actions = (
	createdev		=> \&createdev,
	resizedev		=> \&resizedev,
	doresizedev		=> \&doresizedev,
	
) ;

##############################

if ( exists $actions{$in{action}} ) {
	$actions{$in{action}}->();
} else {
	displaydev();
}

# test
# print "<pre>";
# print Dumper \%in;
# print "</pre>";

# footer
&footer("/", $text{'index'});


# end
exit;
