#!/usr/bin/perl


use strict;
use warnings;

our %text;

require './iscsi-lib.pl';
&ReadParse();

&header($text{'sessions_title'}, "", undef, 1, 1, 0, &help_search_link("ietadm", "man", "doc"),);

if ( -f "/proc/net/iet/session" ) {
	open my $fh, "/proc/net/iet/session" or print "<br><H1>error</h1>";

my $tid="";
#print "<table border=\"1\" width=\"80%\">"; 	

 	while ( <$fh> ) {
# 	while (<DATA>) {

		# target ID
		if ( m/tid\:(\d+)\s+name\:(.*)/) {
			if ($tid ne "") {
				print &ui_columns_end();
				print &ui_columns_end();
			}
			$tid = $1;
			print &ui_columns_start([ $text{'sessions_targetnum'}, $text{'sessions_targetname'} ], "80");
			print &ui_columns_row([ "<b>&nbsp;$1&nbsp;</b>", "&nbsp;$2&nbsp;" ],["align='center'",""]);
			print &ui_columns_row([ "&nbsp;", &ui_columns_start( [ $text{'sessions_sessions'} ], "100", 0, [ "colspan='3' align='center'" ]) ]);

		}

		# session ID
		if ( m/sid\:(\d+)\s+initiator\:(.*)/) {
			print &ui_columns_row([ "<b>$text{'sessions_sessionnum'}</b>", "<b>$text{'sessions_initiatorname'}</b>", "" ], "100", 0);
			print &ui_columns_row([ "$1", "$2", "" ], "100", 0);
		}
		
		# connection ID		
		if ( m/cid\:(\d+)\s+ip\:([\d+\.]+)\s+state\:(\w+)\s+hd\:(\w+)\s+dd\:(\w+)/) {
			print &ui_columns_row([ "<b>$text{'sessions_connectnum'}</b>", "<b>$text{'sessions_sourceip'}</b>", "<b>$text{'sessions_state'}&nbsp;/&nbsp;HD&nbsp;/&nbsp;DD</b>" ], "100", 0);
			print &ui_columns_row([ "$1", "$2", "$3&nbsp;/&nbsp;$4&nbsp;/&nbsp;$5" ], "100", 0);
			print &ui_columns_row([ "", "", "" ], "100", 0);

		}
		
	}

print &ui_table_end();

} else {
	print "<h3>$text{'sessions_noiet'}</h3>";
}

# links to main configuration
print "<hr><a href=index.cgi>$text{sessions_index}</a>\n";

__DATA__
tid:1 name:iqn.2003-03.com.intellique:test.test.iscsi1
        sid:281477535123584 initiator:iqn.2002-07.com.pyxtechnologies:sn.6762d864602a
                cid:0 ip:192.168.2.19 state:active hd:none dd:none
