#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
##
##
##
## ######### PROJECT DESCRIPTION : ###
##
##
##
## ###################################
##
## Made by Sardinha Mickael
## Login   <root@intellique.com>
##
## Started on  Mon Jul 31 13:09:23 2006 Sardinha Mickael
##
## ###################################
##

do '../web-lib.pl';

use diagnostics;
use Data::Dumper;
use Lib_Raid_Rpc;
use Lib_Raid::lib_raid_codes;

&init_config();
&ReadParse();
&header( "", "", undef, 0, 1, 0 );

if ( exists $in{'delunit'} ) {

    my $i = 0;
    my $etat;
    my $ret;
    foreach my $elem ( sort keys(%in) ) {
        if ( $elem =~ /\#/ ) {
            $i = 1;
            my ( $ctl, $array ) = split( "#", $elem );

            ( $etat, $ret ) = Lib_Raid_Rpc::call_action(
                $ctl,
                'delete_array',
                {   luns       => [],
                    arrays     => [$array],
                    drives     => [],
                    raidlevel  => undef,
                    name       => undef,
                    stripesize => undef,
                    size       => undef,
                }
            );
        }
    }
    if ( $i ne 0 ) {
        $ret =~ s/\n/<br>/g;
        if ($etat) {
            print $ret. "<br>";
        }
        else {
            print '<H4>' . $text{'deleted'} . '</H4>';
        }
    }
    else {
        print '<H4>' . $text{'errorparam'} . '</H4>';
    }

    &footer( "./index.cgi", $text{'home'} );
}

if ( exists $in{'rescanctl'} ) {

    my $i = 0;
    my $etat;
    my $ret;

    foreach my $elem ( sort keys(%in) ) {
        if ( my ($controller) = $elem =~ /^(\w+)\#/ ) {
            $i = 1;
			print 'Rescan controller : ', $controller, ' =>';
			( $etat, $ret ) = Lib_Raid_Rpc::call_action( $controller, 'rescan_controller' );
			print $ret, '<br />';
        }
    }
    if ( $i ne 0 ) {
        $ret =~ s/\n/<br>/g;
        if ($etat) {
            print $ret. "<br>";
        }
        else {
            print '<H4>' . $text{'rescaned'} . '</H4>';
        }
    }
    else {
        print '<H4>' . $text{'norescaned'} . '</H4>';
    }

    &footer( "./index.cgi", $text{'home'} );
}

if ( exists $in{'createunit'} ) {

    my %hash;
    my $flg  = 0;
    my $flg2 = 0;
    my $ret;
    my $etat;

    foreach ( keys(%in) ) {
        if (/raid\#/) {
            $flg = 1;
            my ( $temp, $ctl ) = split( '#', $_ );
            if ( exists $hash{$ctl} ) {
                $hash{$ctl}->{'raid'} = $in{$_};
            }
            else {
                $hash{$ctl} = { 'raid' => $in{$_} };
            }
        }
        elsif (/\#/) {
            $flg2 = 1;
            my ( $ctl, $port ) = split( '#', $_ );
            if ( exists $hash{$ctl} ) {
                push @{ $hash{$ctl}->{'disk'} }, $port;
            }
            else {
                $hash{$ctl} = { 'disk' => [$port] };
            }
        }
    }

    if ( $flg2 > 0 and $flg > 0 ) {


        foreach my $ctl ( keys(%hash) ) {
            ( $etat, $ret ) = Lib_Raid_Rpc::call_action(
                $ctl,
                'create_array',
                {   arrays    => [],
                    drives    => $hash{$ctl}->{'disk'},
                    luns      => [],
                    name      => undef,
                    raidlevel => lib_raid_codes::get_raid_level_code(
                        $hash{$ctl}->{'raid'}
                    ),
                    size       => undef,
                    stripesize => undef,
                }
            );
        }

        if ($etat) {
            print $etat. '<br>';
        }
        else {
            print '<H4>' . $text{'created'} . '</H4>';
        }
    }
    else { print '<H4>' . $text{'errorparam'} . '</H4>'; }

    &footer( "./index.cgi", $text{'home'} );
}

if ( exists $in{'rebuild'} ) {

    my $hash;
    my @cmd;
    my $flg  = 0;
    my $flg2 = 0;
    my $ret;
    my $etat;

    foreach my $elem ( keys(%in) ) {

        if ( $elem =~ /unit\#/ ) {
            $flg = 1;
            my ( $unit, $ctl ) = split( "#", $elem );
            $hash->{$ctl}{$unit} = $in{$elem};
        }
        elsif ( $elem =~ /\#/ ) {
            $flg2 = 1;
            my ( $port, $ctl ) = split( "#", $elem );
            $hash->{$ctl}{$port} = $in{$elem};
        }

    }

    if ( $flg2 and $flg ) {

        foreach my $ctl ( keys( %{$hash} ) ) {
            push @cmd, $ctl;
            push @cmd, $hash->{$ctl}{"unit"};
            push @cmd, $hash->{$ctl}{"port"};

            ( $etat, $ret ) = raid::rebuild(@cmd);

            $ret =~ s/\n/<br>/g;
        }
        if ($etat) {
            print $ret. "<br>";
        }
        else {
            print '<H4>' . $text{'rebuilded'} . '</H4>';
        }
    }
    else { print '<H4>' . $text{'errorparam'} . '</H4>'; }

    &footer( "./index.cgi", $text{'home'} );
}

