#!/usr/bin/perl
# conf_smb.cgi
# Display Windows networking options

require './samba-lib.pl';
require './krb5-lib.pl';
use Data::Dumper;

&ReadParse();

sub isnonull {
	$_[0] ? 0 : 1;
}

%conf = &get_config();

# check acls
%access = &get_module_acl();
&error_setup("<blink><font color=red>$text{'eacl_aviol'}</font></blink>");
&error("$text{'eacl_np'} $text{'eacl_pcs'}") unless $access{'conf_smb'};

&ui_print_header(undef, $text{'smb_title'}, "");

&get_share("global");

$gap = "&nbsp;" x 3;

# Hash Name Security
$name_security = {
	''		=> $text{'default'},
	'share'		=> $text{'smb_sharelevel'},
	'user'		=> $text{'smb_userlevel'},
	'server'	=> $text{'smb_passwdserver'},
	'domain'	=> $text{'smb_domain'},
	'ads'		=> $text{'smb_ads'},
};

# Domaine
$domaine = &getval("security");
$domaine = $in{'domain'} if ( exists $in{'domain'} );
$select_security{$domaine}	= "selected";

# Recuperation des parametres
$default		= &getval("default");
$message_command	= &getval("message command");
$os_level		= &getval("os level");
$protocol		= &getval("protocol");
$preferred_master	= &getval("preferred master") ? "no" : "yes";
$remote_def		= &getval("remote announce") ? "0" : "1";
$netbios_name		= &getval("netbios name");
$netbios_aliases	= &getval("netbios aliases");
$workgroup		= &getval("workgroup");
$server_string		= &getval("server string");
$wins_server		= &getval("wins server");
$max_disk_size		= &getval("max disk size");

$inherit_acls		= &getval("inherit acls");
$select_inherit_acls	[!isnonull( $inherit_acls )]	= "checked";

$inherit_permissions	= &getval("inherit permissions");
$select_inherit_permissions	[!isnonull( $inherit_permissions )]	= "checked";

$password_server	= &getval("password server");

$separator		= &getval("winbind separator");
$idmap_uid		= &getval("idmap uid");
$idmap_gid		= &getval("idmap gid");


$select_workgroup	[isnonull( $workgroup )]	= "checked";
$select_server_string	[isnonull( $server_string )]	= "checked";
$max_disk_size_def	= isnonull( $max_disk_size );

# Wins  support
$wins = 0;
$wins = 1 if ( &isfalse("wins support") );
$wins = 2 if ( &isfalse("wins support") && ( &getval("wins server") eq "" ) );








# Html
my $min_realm	= $conf{'realm'};
$min_realm	=~ tr/A-Z/a-z/;

my $server		= $1 if ( $conf{'admin_server'} =~ m/^(.*)\.$min_realm/ );
my $realm_port		= $conf{'admin_port'};
my $dns_lookup_kdc	= "<input type=hidden name=dns_kdc value=1>" if ($conf{'dns_lookup_kdc'} ne "false");


print <<EOF;
<table border width=100%>
 	<tr $tb><td><b>$text{'sec_title'}</b></td></tr>
	<tr $cb> <td>

		<table width=100%>
			<tr>
				<td><b>$text{'smb_security'}</b></td>
				<td colspan=3>
				
					<form NAME="menu">
						<select name="security_live" onChange="change_site();">
							<option value=conf_smb.cgi?domain= $select_security{''}> $text{'default'}
							<option value=conf_smb.cgi?domain=share $select_security{'share'}> $text{'smb_sharelevel'}
							<option value=conf_smb.cgi?domain=user $select_security{'user'}> $text{'smb_userlevel'}
							<option value=conf_smb.cgi?domain=server $select_security{'server'}> $text{'smb_passwdserver'}
							<option value=conf_smb.cgi?domain=domain $select_security{'domain'}> $text{'smb_domain'}
							<option value=conf_smb.cgi?domain=ads $select_security{'ads'}> $text{'smb_ads'}
	
						</select>
					</form>
	
					<script>
						function change_site() {
							var site = document.menu.security_live.selectedIndex;
							{
								window.location.href = document.menu.security_live.options[site].value;
							}
						}
					</script>
				</td>
			</tr>
		</table>
	</td></tr>
</table>



EOF

print <<EOF;
<form action=save_smb.cgi>
	<table border width=100%>
		<tr $tb><td><b>$text{'smb_title'}</b></td></tr>
		<tr $cb><td>

			<table width=100% border=0>
				<input type=hidden name=security value="$domaine">
				
				<tr>
					<td width=50%><b>$text{'smb_workgroup'}</b></td>
					<td colspan=2>
						<input type=radio name=workgroup_def value=1 $select_workgroup[1]>&nbsp;$text{'default'}
					</td>
					<td>
					  <input type=radio name=workgroup_def value=0 $select_workgroup[0]>&nbsp;<input name=workgroup size=20 value="$workgroup">
					</td>
				</tr>
	
	
				<tr>
					<td><b>$text{'smb_description'}</b></td>
					<td colspan=2>
						<input type=radio name=server_string_def value=1 $select_server_string[1]> $text{'default'}
					</td>
					<td>
					  <input type=radio name=server_string_def value=0 $select_server_string[0]>&nbsp;<input name=server_string size=20 value="$server_string">
					</td>
				</tr>
EOF

if ( ($domaine eq 'server') or ($domaine eq 'domain') ) {
	print <<EOF;
				<tr>
					<td><b>$text{'smb_passwdserver'}</b></td>
					<td colspan=3><input name=password_server size=20 value="$password_server"></td>
				</tr>
EOF
}

if ( $domaine eq 'ads' ) {
	print <<EOF;
				<tr>
					<td><b>$text{'smb_passwdserver'}</b></td>
					<td colspan=3><input name=password_server size=20 value="$password_server"> : <input name=realm_port size=5 value="$realm_port"></td>
				</tr>
				<tr>
					<td><b>$text{'bind_realm'}</b></td>
					<td colspan=3><input name=realm size=20 value="$min_realm">$dns_lookup_kdc</td>
				</tr>
EOF
}


print <<EOF;
				<tr>
					<td><b>$text{'inherit_permissions'}</b></td>
					<td colspan=3><input type="radio" name="inherit_permissions" value="yes" $select_inherit_permissions[1]> $text{'yes'}
						$gap <input type="radio" name="inherit_permissions" value="no" $select_inherit_permissions[0]> $text{'no'}</td>
				</tr>
			</table>
		</td></tr>
	</table>

<p><input type=submit value=$text{'save'}>
</form>

EOF

&ui_print_footer("", $text{'index_sharelist'});
