#!/usr/bin/perl
# save_net.cgi
# Save inputs from conf_net.cgi

require './samba-lib.pl';

&ReadParse();
&lock_file($config{'smb_conf'});
$global = &get_share("global");

# check acls
%access = &get_module_acl();
&error_setup("<blink><font color=red>$text{'eacl_aviol'}</font></blink>");
&error("$text{'eacl_np'} $text{'eacl_pcs'}") unless $access{'conf_smb'};

$whatfailed = $text{'savesmb_fail'};
&setval("workgroup", $in{workgroup_def} ? "" : $in{workgroup}, "");


&setval("server string", $in{server_string_def} ? "" : $in{server_string}, "");
&setval("netbios name", $in{'netbios_name'}, "");
&setval("netbios aliases", $in{'netbios_aliases'}, "");

&setval("security", $in{security}, "no");

# on n'utilise qu'un seul switch pour les acls et les perms
&setval("inherit acls", $in{inherit_permissions}, "no");
&setval("inherit permissions", $in{inherit_permissions}, "no");

if ($in{security} eq "server" && $in{password_server} !~ /\S/) {
	&error($text{'savesmb_server'});
}
&setval("password server", $in{password_server}, "");

$in{'realm'} eq "" || $in{'realm'} =~ /^\S+$/ || &error($text{'bind_erealm'});
&setval("realm", $in{'realm'});

if ( ($in{security} eq "domain") or ($in{security} eq "ads") ) {
	
	if ( $in{'separator'} eq "" ) {
		 $in{'separator'} = '+' ;
	}
	
	&setval("winbind separator", $in{'separator'});
	
	if ( $in{'uid'} eq "" ) {
		$in{'uid'} = "10000-20000" ;
	} elsif ( $in{'uid'} !~ /^\d+\-\d+$/ ) {
		&error($text{'bind_euid'});
	} 
	
	&setval("idmap uid", $in{'uid'});
	
	if ( $in{'gid'} eq "" ) {
		$in{'gid'} = "10000-20000" ;
	} elsif ( $in{'gid'} !~ /^\d+\-\d+$/ ) {
		&error($text{'bind_egid'});
	} 
	
	&setval("idmap gid", $in{'gid'});
}

if ($global) { &modify_share("global", "global"); }
else { &create_share("global"); }
&unlock_file($config{'smb_conf'});

if ( $in{security} eq "domain" ) {
	if ( system( "cmp /etc/pam.d/samba /etc/pam.d/samba.norm" ) == 0 ) {
		`cp /etc/pam.d/samba.pdc.nt /etc/pam.d/samba`;
	}
}
else {
	if ( system( "cmp /etc/pam.d/samba /etc/pam.d/samba.pdc.nt" ) == 0 ) {
		`cp /etc/pam.d/samba.norm /etc/pam.d/samba`;
	}
}

if ( $in{security} eq "ads" ) {

	&error_setup($text{'save_err', $config{'krb5_conf'}});
	# Write the config file
	&lock_file($config{'krb5_conf'});
	
	
	my $min_realm	= $in{'realm'};
	my $maj_realm	= $in{'realm'};
	$maj_realm	=~ tr/a-z/A-Z/;
	
	my $server	= $in{'password_server'} . "." . $min_realm;
	$server		.= ":$in{'realm_port'}" if ( $in{'realm_port'} );
	
	my $dns		= "dns_lookup_kdc = false\n" if (!$in{'dns_kdc'});
	
	open(FILE, "> $config{'krb5_conf'}");
	
	print FILE <<EOF;
[libdefaults]
	default_realm = $maj_realm
	$dns
[realms]
	$maj_realm = {
		kdc = $server
		admin_server = $server
	}

[domain_realm]
	.$maj_realm = $maj_realm
	$min_realm = $maj_realm
	.$min_realm = $maj_realm

EOF
	
	close(FILE);
	
	&unlock_file($config{'krb5_conf'});
}

&webmin_log("smb", undef, undef, \%in);
&redirect("");

