## ######### PROJECT NAME : ##########
##
## confstoriq.pl for /usr/lib/webmin-1.450/storiq-config
##
## Made by Pujos Sylvain
##
## ###################################
##

do '../web-lib.pl';

use Data::Dumper;
use Objet_Conf;
use Lib_Disk;
use Lib_Raid_Rpc;

&init_config();

#Fonction qui modifie alerte.conf
sub set_conf {

    # Recuperation des arguments
    my ( $file, $key, $value, $section ) = @_;

    # Creation de l'Objet Logger
    my ( undef, $logger ) = new Objet_Logger();

    # Creation de l'Objet Conf
    my ( $err, $conf ) = new Objet_Conf( $file, $logger );
    return ( 3, "UNKNOWN: Pb creation Objet_Conf: $conf" ) if $err;

    # Modification de la valeur de la clé
    $conf->set_value( $key, $value, $section );
    $conf->save();
}

#Fonction qui lis alerte.conf
sub get_conf {

    # Recuperation des arguments
    my ( $file, $key, $section ) = @_;

    # Creation de l'Objet Logger
    my ( undef, $logger ) = new Objet_Logger();

    # Creation de l'Objet Conf
    my ( $err, $conf ) = new Objet_Conf( $file, $logger );
    return ( 3, "UNKNOWN: Pb creation Objet_Conf: $conf" ) if $err;

    # Modification de la valeur de la clé
    return $conf->get_value( $key, $section );
}

# focntion pour recuperer les infos des disques
sub get_disk {
    return Lib_Disk::get_disk_info();
}

# fonction recuperant les infos des controlleurs
sub do_controler {
    my $hash = Lib_Raid_Rpc::get_all_info();
    my %newhash;

    # on rempli la hash principale avec les infos desirés
    foreach my $ctl ( keys %$hash ) {
        $newhash{$ctl} = {};
        foreach my $unit ( keys( %{ $hash->{$ctl}->{'arrays'} } ) ) {
            $newhash{$ctl}->{$unit} = { type => 'unit' };
        }
        foreach my $drive ( keys( %{ $hash->{$ctl}->{'drives'} } ) ) {
			$newhash{$ctl}->{$drive} = { type => 'drive' };
        }
    }

    return \%newhash;
}

sub create_controf_conffile {
    my $path2 = "/etc/storiq/control.conf";
    my $test  = shift;

    unlink $path2;

    open( FD, "> $path2" )
        or die "Erreur de creation du fichier control.conf\n";

    foreach my $controler ( sort keys( %{$test} ) ) {

        my @list_elem = sort keys( %{ $test->{$controler} } );

        my $list = join( ' ', @list_elem );

        print FD "$controler = $list \n";

    }

    close(FD);
}

1;
