#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
##
## fileconf.cgi for /usr/lib/webmin-1.450/storiq-config
## 
## Made by Pujos Sylvain
## 
## ###################################
##

require './confstoriq.pl';

use Data::Dumper;
use Objet_Alerte;
use raid_control;
use Objet_Logger;

use Sys::Hostname;

&ReadParse();
&header($text{'page_title'}, "", undef, 0, 1, 0);


######## Set du serveur mail

my $path="/etc/storiq/alerte.conf";

# on enregistre la conf et envoie d'un mail de test apres avoir cliquer sur "save and test"
if ( exists $in{'save'} ) {
	# enregistrement des parametres en fonction des champs renseign
    if ( exists $in{'dest'}){
		&set_conf($path, "destinataire", $in{'dest'}, "MAIL" ) ;}

    if ( exists $in{'exp'}){
		&set_conf($path, "expediteur", $in{'exp'}, "MAIL" ) ;}

    if ( exists $in{'smtp'}){
		&set_conf($path, "smtp", $in{'smtp'}, "MAIL" ) ;}

	if ( exists $in{'alerte'}){
		&set_conf($path, "alerte", $in{'alerte'}, "MAIL" ) ;}

    if ( exists $in{'hostmng'}) {
	&set_conf($path, "host_manager", $in{'hostmng'}, "SNMP" ) ;}
    
    if ( exists $in{'portudp'}) {
	&set_conf($path, "udp_port", $in{'portudp'}, "SNMP" ) ;}
    
    if ( exists $in{'comu'}) {
	&set_conf($path, "community", $in{'comu'}, "SNMP" ) ;}
    
    if ( exists $in{'snmpvers'}) {
	&set_conf($path, "version_snmp", $in{'snmpvers'}, "SNMP" ) ;}
    
    if ( exists $in{'oidvers'}) {
	&set_conf($path, "OID_enterprise", $in{'oidvers'}, "SNMP" ) ;}
    
    if ( exists $in{'snmpal'}) {
	&set_conf($path, "alerte", $in{'snmpal'}, "SNMP" ) ;}
    
    # affichage de confirmation des modifs
    print '<H4>'.$text{'done'}.'</H4>';

}

if ( exists $in{'test'} ) {
	if ( exists $in{'alerte'}){
		if ( $in{'alerte'} eq 'yes' ) {
			undef, my $logger = new Objet_Logger();
		    $logger->set_conf(\ qq{
				log4perl.logger                                     = ALL, LOG-WARN

				log4perl.appender.LOG-WARN                          = Log::Log4perl::Appender::Screen
				log4perl.appender.LOG-WARN.stderr                   = 1
				log4perl.appender.LOG-WARN.layout                   = Log::Log4perl::Layout::PatternLayout
				log4perl.appender.LOG-WARN.layout.ConversionPattern = %m %n
				log4perl.appender.LOG-WARN.Filter                   = FILTER-WARN
				log4perl.filter.FILTER-WARN                         = Log::Log4perl::Filter::LevelRange
				log4perl.filter.FILTER-WARN.LevelMin                = WARN
				log4perl.filter.FILTER-WARN.LevelMax                = OFF
				log4perl.filter.FILTER-WARN.AcceptOnMatch           = true
		    });
			
			my ($err, $msg ) = raid_control::test_alert( $logger );
			if ( $err ) {
				# affichage de probleme
				print '<H4>'. $msg .'</H4>';
		    }
			else {
				# affichage de confirmation des modifs
				print '<H4>'.$text{'done_test'}.'</H4>';
			}
		}
		else {
			# affichage de confirmation des modifs
			print '<H4>'.$text{'done'}.'</H4>';
		}
	}
}


######## Set du control

if ( exists $in{'savecontrol'}){
    my $path_control = "/etc/storiq/control.conf";
    my $test={};

    foreach my $element ( keys (%in)) {
		print 	next unless ($element =~ /\#/);
		my @tab = split ("#", $element);
		$test->{$tab[0]}{ $tab[1] } = undef;
    }

    &create_controf_conffile($test);
    # affichage de confirmation des modifs
    print '<H4>'.$text{'done'}.'</H4>';
}


##### affichage du lien vers la page principale du module
&footer("", $text{'index_home'});
