#!/usr/bin/perl 
## ######### PROJECT NAME : ##########
##
## index.cgi for /usr/lib/webmin-1.450/storiq-config
##
## Made by Pujos Sylvain
##
## ###################################
##

require './confstoriq.pl';
do '../web-lib.pl';
require '../ui-lib.pl';

&init_config();
&ReadParse();

&header( $text{'index_title'}, "" );

&footer( "/", $text{'index'} );

###########################
## MAIL et SNMP
###########################

# Recuperation des infos ds le fichier de conf
my $path = "/etc/storiq/alerte.conf";

my $desti       = &get_conf( $path, "destinataire", "MAIL" );
my $exped       = &get_conf( $path, "expediteur",   "MAIL" );
my $ssmtp       = &get_conf( $path, "smtp",         "MAIL" );
my $alerte_mail = &get_conf( $path, "alerte",       "MAIL" );

my $host_manager = &get_conf( $path, "host_manager",   "SNMP" );
my $udp_port     = &get_conf( $path, "udp_port",       "SNMP" );
my $community    = &get_conf( $path, "community",      "SNMP" );
my $snmp_version = &get_conf( $path, "version_snmp",   "SNMP" );
my $oid_version  = &get_conf( $path, "OID_enterprise", "SNMP" );
my $alerte_snmp  = &get_conf( $path, "alerte",         "SNMP" );

print <<EOF;
    <h3 align="center">$text{'mail_title'}</h3>
    <form method="get" action="fileconf.cgi"> 
    <table>
    <tr>
    <td width=300>$text{'recipient'}</td>
    <td><input name="dest" value="$desti" size=60></td>
    </tr>
    <tr>
    <td></td><td>$text{'ex_mail'}</td>
    </tr>
    <tr>
    <td>$text{'sender'}</td>
    <td><input name="exp" value="$exped" size=60></td>
    </tr>
    <tr>
    <td></td><td>$text{'ex_mail'}</td>
    </tr>
    <tr>
    <td>$text{'server'}</td>
    <td><input name="smtp" value="$ssmtp" size=60></td>
    </tr>

    </table>

    <h3 align="center">$text{'snmp_title'}</h3>

	<table>
	<tr>
	<td width=300>$text{'hostmanager'}</td>
	<td><input name="hostmng" value="$host_manager" size=60></td>
	</tr>
	<tr>
	<td width=300>$text{'udpport'}</td>
	<td><input name="portudp" value="$udp_port" size=60></td>
	</tr>
	<tr>
	<td width=300>$text{'comunity'}</td>
	<td><input name="comu" value="$community" size=60></td>
	</tr>
	<tr>
	<td width=300>$text{'snmpversion'}</td>
	<td><input name="snmpvers" value="$snmp_version" size=60></td>
	</tr>
	<tr>
	<td width=300>$text{'oidverision'}</td>
	<td><input name="oidvers" value="$oid_version" size=60></td>
	</tr>
</table>

<br><br>

<table>
	<tr>
	<td>$text{'alert'}</td>
EOF

#afficher le radiobox pour l'alerte en fonction de son etat y/n
print '<td><input name="alerte" type="radio" value="yes" ';
print 'checked="checked" ' if ( $alerte_mail eq "yes" );
print '>' . $text{'yes'} . '<input name="alerte" type="radio" value="no" ';
print 'checked="checked" ' if ( $alerte_mail ne "yes" );
print '>' . $text{'no'} . '</td>';

print <<EOF;
    </tr>
	<tr>
	<td>$text{'snmp_alert'}</td>
EOF

#afficher le radiobox pour l'alerte en fonction de son etat y/n
print '<td><input name="snmpal" type="radio" value="yes" ';
print 'checked="checked" ' if ( $alerte_snmp eq "yes" );
print '>' . $text{'yes'} . '<input name="snmpal" type="radio" value="no" ';
print 'checked="checked" ' if ( $alerte_snmp ne "yes" );
print '>' . $text{'no'} . '</td>';

print <<EOF;
    </tr>
	</table>
	
	<br>
		<input type="submit" value="$text{validate}" name="save">
		<input type="submit" value="$text{test}" name="test">
		<input type="reset" value="$text{cancel}">
	<br><br><HR>
	</form>

EOF

###########################
## CONTROLEURS
###########################

my $path2 = "/etc/storiq/control.conf";

# creation de la hash principale contenant toutes les infos controlleurs
my $ctl = &do_controler();

if ($ctl) {

    # set de l'etat des controleurs et disques precedement coche
    foreach my $ctrl ( keys( %{$ctl} ) ) {
        my $line = &get_conf( $path2, $ctrl );
        foreach my $elem ( split( " ", $line ) ) {
            $ctl->{$ctrl}{$elem}{'etat'} = "checked"
                if ( exists $ctl->{$ctrl}{$elem} );
        }
    }

    print <<EOF;
<script language="JavaScript">

function selectAll() {
 d = document.myform;
 for (i = 0; i < d.elements.length; i++) {
   if (d.elements[i].type == "checkbox") {
     d.elements[i].checked = true;
   }
 }
}

function deselectAll() {
 d = document.myform;
 for (i = 0; i < d.elements.length; i++) {
   if (d.elements[i].type == "checkbox") {
     d.elements[i].checked = false;
   }
 }
}

</script>

    <h3 align="center">$text{'control_title'}</h3><br>
        <form name="myform" method="get" action="fileconf.cgi"> <center>        
        <table border=2>
        <tr>
        <td>$text{'controleur'}</td>
        <td>$text{'volume'}</td>
        <td>$text{'disk'}</td>
        </tr>

EOF

    foreach my $ctl_ckbox ( sort keys( %{$ctl} ) ) {
        print "<tr><td>$ctl_ckbox</td>";
        print '<td>';

      # affichage des checkbox concernants les "unit" en fonction de leur etat
        foreach my $info_ctl ( sort keys %{ $ctl->{$ctl_ckbox} } ) {
            if ( $info_ctl eq '-' ) { print "&nbsp"; next }

            if ( $ctl->{$ctl_ckbox}{$info_ctl}{'type'} eq 'unit' ) {
                print '<input type="checkbox"  name="'
                    . $ctl_ckbox . '#'
                    . $info_ctl
                    . '" value="yes" '
                    . $ctl->{$ctl_ckbox}{$info_ctl}{etat}
                    . ">$info_ctl";
            }
        }
        print '</td>';
        print '<td>';

      # affichage des checkbox concernants les "drive" en fonction de leur etat
        foreach my $info_ctl ( sort keys %{ $ctl->{$ctl_ckbox} } ) {
            if ( $ctl->{$ctl_ckbox}{$info_ctl}{'type'} eq 'drive' ) {
                print '<input type="checkbox" name="'
                    . $ctl_ckbox . '#'
                    . $info_ctl
                    . '" value="yes" '
                    . $ctl->{$ctl_ckbox}{$info_ctl}{etat}
                    . ">$info_ctl";
            }
        }

        print '</td>';
        print '</tr>';
    }

    print <<EOF;
      </tr>
      </table></center>
      <br><input type="submit" value="$text{validate}" name="savecontrol">
      
      <input type="button" name="CheckAll" value="$text{selectall}" onclick="if (this.name == 'CheckAll'){this.value = '$text{unselectall}';selectAll();this.name='UnCheckAll';}      else{deselectAll();this.name='CheckAll';this.value = '$text{selectall}';} ">
      <input type="reset" value="$text{cancel}">
      </form>
EOF

}
