#!/usr/bin/perl

use Data::Dumper;
require './vsftpd-lib.pl';

&ReadParse();

#%conf = &get_config();
&ui_print_header(undef, $text{'vsftpd_title'}, "", undef, 1, 1, 0);

%configuration = &getconfig( $config{'vsftp_conf'} );

if ( not -f $config{'vsftd_binary'}) {
	print qq(
		<H3>$text{'notinstalled'}</h3>
    </body>
	</html>
	);
	exit;
}

## Authentification
if ( exists $in{'auth'} && $in{'auth'} ) {
	$authe = $in{'auth'};
}
elsif ( exists $in{'auth'} ) {
	$authe = "vide";
}
else {
	$authe = &authenfication_mode( $config{'pam_conf'}, $configuration{ guest_enable });
}
$select_security{$authe}	= "selected";


# Recuperation des parametres

$local_root		= $configuration{ local_root };
$guest_username = "ftp";
$guest_username	= $configuration{ guest_username } if ( exists $configuration{ guest_username } );

$bool_chroot_local_user									= &get_boolean_value( $configuration{chroot_local_user} );
$select_chroot_local_user[ $bool_chroot_local_user ]	= 'checked="checked"';
$bool_guest_enable										= &get_boolean_value( $configuration{guest_enable});
$select_guest_enable[ $bool_guest_enable ]				= 'checked="checked"';

$bool_readonly	= &get_readonly(
		$authe, $bool_guest_enable,
		$configuration{ download_enable },
		$configuration{ write_enable },
		$configuration{ anon_mkdir_write_enable },
		$configuration{ anon_upload_enable },
		$configuration{ anon_other_write_enable },
		$configuration{ anon_world_readable_only }
);
$select_readonly[ $bool_readonly ]	= 'checked="checked"';



print <<EOF;
<table border width=100%>
 	<tr $tb><td><b>$text{'sec_title'}</b></td></tr>
	<tr $cb> <td>

		<table width=100%>
			<tr>
				<td><b>$text{'vsftpd_auth'}</b></td>
				<td colspan=3>
				
					<form NAME="menu">
						<select name="security_live" onChange="change_site();">
							<option value=index.cgi?auth=vide $select_security{'vide'}>&nbsp;
							<option value=index.cgi?auth=local_guest $select_security{'local_guest'}> $text{'vsftpd_local_guest'}
							<option value=index.cgi?auth=local $select_security{'local'}> $text{'vsftpd_local'}
							<option value=index.cgi?auth=virtual $select_security{'virtual'}> $text{'vsftpd_virtual'}
							<option value=index.cgi?auth=openldap $select_security{'openldap'}> $text{'vsftpd_openldap'}
						</select>
					</form>
	
					<script>
						function change_site() {
							var site = document.menu.security_live.selectedIndex;
							{
								window.location.href = document.menu.security_live.options[site].value;
							}
						}
					</script>
				</td>
			</tr>
		</table>
	</td></tr>
</table>



EOF

if ( $authe ne 'vide' ) {

	print <<EOF;
	<form action=save.cgi>
		<table border width=100%>
			<tr $tb><td><b>$text{'vsftpd_options'}</b></td></tr>
			<tr $cb><td>
	
				<table width=100% border=0>
	
	<input type=hidden name=anonymous_enable value="NO">
	<input type=hidden name=local_enable value="YES">
	<input type=hidden name=listen value="YES">
	<input type=hidden name=authe value=$authe>
					<tr>
						<td><b>$text{'vsftpd_readonly'}</b></td>
						<td><input type="radio" name="readonly" value="yes" $select_readonly[1]> $text{'yes'}
							<input type="radio" name="readonly" value="no" $select_readonly[0]> $text{'no'}
						</td>
					</tr>
EOF


	if ( $authe eq 'local_guest' ) {
		print <<EOF;
			<input type=hidden name=guest_enable value="YES">
				<tr>
					<td><b>$text{'vsftpd_guest_username'}</b></td>
					<td><input name=guest_username size=33 value="$guest_username"></td>
				</tr>
				<tr>
					<td><b>$text{'vsftpd_chroot_local_user'}</b></td>
					<td><input type=radio name=chroot_local_user value="no" $select_chroot_local_user[0]> $text{'no'}
						<input type=radio name=chroot_local_user value="yes" $select_chroot_local_user[1]>&nbsp;<input name=local_root size=20 value="$local_root">
					</td>
				</tr>
EOF
	}

	if ( $authe eq 'local' ) {
		print <<EOF;
			<input type=hidden name=guest_enable value="NO">
				<tr>
					<td><b>$text{'vsftpd_chroot_local_user'}</b></td>
					<td><input type=radio name=chroot_local_user value="no" 
					onclick='e = form.elements["local_root"]; e.disabled = true; for(i=0; i<e.length; i++) { e[i].disabled = true; }' $select_chroot_local_user[0]> $text{'no'}
						<input type=radio name=chroot_local_user value="yes"  
						 onclick='e = form.elements["local_root"]; e.disabled = false; for(i=0; i<e.length; i++) { e[i].disable = false; } '  $select_chroot_local_user[1]>&nbsp;<input name=local_root size=20 value="$local_root">
					</td>
				</tr>
EOF
	}

	if ( $authe eq 'virtual' ) {
		print <<EOF;
			<input type=hidden name=guest_enable value="YES">
				<tr>
					<td><b>$text{'vsftpd_guest_username'}</b></td>
					<td><input name=guest_username size=33 value="$guest_username"></td>
				</tr>
				<tr>
					<td><b>$text{'vsftpd_chroot_local_user'}</b></td>
					<td><input name=local_root size=33 value="$local_root">&nbsp;($text{'facultatif'})
					</td>
				</tr>
EOF
	}

	if ( $authe eq 'openldap' ) {
		print <<EOF;
				<tr>
					<td><b>$text{'vsftpd_guest_username'}</b></td>
					<td><input type=radio name=guest_enable value="no" $select_guest_enable[0]> $text{'no'}
						<input type=radio name=guest_enable value="yes" $select_guest_enable[1]>&nbsp;<input name=guest_username size=33 value="$guest_username"></td>
				</tr>
				<tr>
					<td><b>$text{'vsftpd_chroot_local_user'}</b></td>
					<td><input name=local_root size=33 value="$local_root">&nbsp;($text{'facultatif'})
					</td>
				</tr>
EOF
	}



	print <<EOF;
				</table>
			</td></tr>
		</table>

	<p><input type=submit value=$text{'save'}>
	</form>
EOF
}

print <<EOF;
<hr>
<table width=100%><tr>
	<form action=restart.cgi>
		<tr>
			<td><input type=submit value=$text{'index_restart'}></td>
			<td>$text{'index_restartmsg'}</td>
		</tr>
	</form>
</table>
</body>
</html>
EOF

